#!/bin/bash
CURRENT="/opt/inseego"
# Copy Compose from upgrade folder to EM_PATH
EM_PATH="/opt/inseego/bin/edge_manager"
NGINX_PATH="/opt/inseego/srv"
echo "EM deployed in Cloud or Private network?
Choose 1 for Cloud and 2 for Private"
read flag
if [ $flag == 1 ]
then
  cd /home/$USER/upgrade/aws && cp docker-compose.yaml $EM_PATH/docker-compose.yaml
elif [ $flag == 2 ]
then
  cd /home/$USER/upgrade/esxi && cp docker-compose.yaml $EM_PATH/docker-compose.yaml
else
  exit 1;
fi
sudo chown $USER:$USER $EM_PATH/* $EM_PATH/.env
cd $NGINX_PATH && sudo chown $USER:$USER .
aws ecr get-login-password --region us-west-2 | docker login --username AWS --password-stdin 836891784212.dkr.ecr.us-west-2.amazonaws.com
cat /opt/inseego/bin/edge_manager/.env | grep -q 'EM_VERSION'
return=$?
if [ $return == 1 ]
then
	 sed -i '2 a EM_VERSION=2022.22.1.2' /opt/inseego/bin/edge_manager/.env
else
	 sed -i "s/EM_VERSION=.*/EM_VERSION=2022.22.1.2/g" /opt/inseego/bin/edge_manager/.env
fi
cat /opt/inseego/bin/edge_manager/.env | grep -q 'LOGGING_LEVEL'
log=$?
if [ $log == 1 ]
then
	 sed -i '3 a LOGGING_LEVEL=DEBUG' /opt/inseego/bin/edge_manager/.env
fi
cd $EM_PATH && docker-compose up -d
echo "Upgrading the EM to latest version"
sleep 40
docker ps
