#!/bin/bash
# Copy Compose from upgrade folder to EM_PATH
EM_PATH="/opt/inseego/bin/edge_manager"
NGINX_PATH="/opt/inseego/srv"
echo "EM deployed in Cloud or Private network?
Choose 1 for Cloud and 2 for Private"
read flag
if [ $flag == 1 ]
then
  cd /home/$USER/upgrade/aws && cp docker-compose.yaml $EM_PATH/docker-compose.yaml
elif [ $flag == 2 ]
then
  cd /home/$USER/upgrade/esxi && cp docker-compose.yaml $EM_PATH/docker-compose.yaml
else
  exit 1;
fi
#Changing the Ownership of $EM_PATH directory
sudo chown $USER:$USER $EM_PATH/* $EM_PATH/.env
cd $NGINX_PATH && sudo chown $USER:$USER .
#AWS ECR Authentication for pulling docker images
aws ecr get-login-password --region us-west-2 | docker login --username AWS --password-stdin 836891784212.dkr.ecr.us-west-2.amazonaws.com > /dev/null
cat $EM_PATH/.env | grep -q 'EM_VERSION'
return=$?
if [ $return == 1 ]
then
	 sed -i '2 a EM_VERSION=2023.2.1.1' $EM_PATH/.env
else
	 sed -i "s/EM_VERSION=.*/EM_VERSION=2023.2.1.1/g" $EM_PATH/.env
fi
cat $EM_PATH/.env | grep -q 'LOGGING_LEVEL'
log=$?
if [ $log == 1 ]
then
	 sed -i '3 a LOGGING_LEVEL=DEBUG' $EM_PATH/.env
fi
cat $EM_PATH/.env | grep -q 'DEBIAN_REPO_URL'
repo=$?
if [ $repo == 1 ]
then
	sed -i '4 a DEBIAN_REPO_URL=https://repo.inseego5g.net/debs/' $EM_PATH/.env
fi
cat $EM_PATH/.env | grep -q 'CURRENT_ENV'
env=$?
if [ $env == 1 ]
then
	sed -i '5 a CURRENT_ENV=prod' $EM_PATH/.env
fi
sed -i '6 a LOG_DRIVER=json-file' /opt/inseego/bin/edge_manager/.env
#Upgrading the EM to latest version
cd $EM_PATH && docker-compose up -d
echo "Upgrading the EM to latest version"
sudo rm -rf /opt/2022.16.1.0/ /opt/2022.17.1.0/ /opt/2022.17.1.1/ /opt/2022.17.2.0/ /opt/2022.17.3.0/ /opt/2022.20.1.0/ /opt/2022.21.1.0/ /opt/2022.22.1.0/ > /dev/null 2>&1
cat $EM_PATH/.env | grep -q 'EM_VERSION=2023.2.1.1'
test=$?
if [ $test == 0 ]
then
	echo "EM upgraded successfully..." 
    docker rmi -f 7521461872fb 2d990140f2c3 6590b41bb5d1 8188a33232f1 4f442b3865c5 75684e74c244 15c68cf73b1e 0812ecd32132 988391fd5be7 7ae2a9767d6e 7858f294bb90 097463f3e4f9 6a543fd2cff2 523a29705292 285cfe7cf15e b2d13d73c4f0 c9034324e20a f63c5e84dd31 454711af3d3a e2009d08aec6 a8d57db6d544 a72a48acb34d > /dev/null 2>&1
else
	echo "EM upgrade failed..."
fi
sleep 10 
#Checking the docker container status after upgrading
docker ps

