import subprocess
from time import sleep
from os.path import exists

from user_input import input_func


def main():
    print('Please choose DHCP or Static Deployment')

    while True:
        dhcp_or_static = input('Enter 1 for DHCP or 2 for Static: ')

        is_dhcp = True if dhcp_or_static == '1' else False
        is_static = True if dhcp_or_static == '2' else False

        if is_dhcp or is_static:
            break
        else:
            print('Wrong input given, Please give correct input.')

    is_em_behind_nat = input('Is your EM behind NAT? (Y/N): ').lower() == 'y'

    gateway4 = None
    nameserver_addresses = None
    c = '#'
    addresses = None

    if is_static:
        print("Please enter VM details")
        addresses_with_mask = input('Enter VM ip address/mask: ')
        addresses = addresses_with_mask.split('/')[0]
        gateway4 = input('Enter VM gateway ip: ')
        nameserver_addresses = input('Enter nameserver_addresses: ')
        c = ' '
    else:
        addresses_with_mask = ''
        gateway4 = ''
        nameserver_addresses = ''
    

    s = f"""# This is the network config written by 'subiquity'
network:
  version: 2
  renderer: networkd
  ethernets:
    ens160:
      dhcp4: {'true' if is_dhcp else 'false'}
    {c} addresses: [{addresses_with_mask}]
    {c} gateway4: {gateway4}
    {c} nameservers:
    {c}   addresses: [{nameserver_addresses}]"""

    with open('netcfg.yaml', 'w+') as file:
        file.write(s)

    if exists('/etc/netplan/01-netcfg.yaml'):
        process0 = subprocess.Popen(['mkdir backup-netplan/'],
                                    shell=True,
                                    stdout=subprocess.PIPE,
                                    stderr=subprocess.PIPE)

        # Getting output logs and error logs
        stdout0, stderr0 = process0.communicate()
        if stdout0:
            print(f'netplan-script :: {stdout0}')
        if stderr0:
            print(f'netplan-script, error :: {stderr0}')

        command = 'sudo mv /etc/netplan/01-netcfg.yaml backup-netplan/01-netcfg-backup.yaml'
        process1 = subprocess.Popen([command],
                                    shell=True,
                                    stdout=subprocess.PIPE,
                                    stderr=subprocess.PIPE)

        # Getting output logs and error logs
        stdout1, stderr1 = process1.communicate()
        if stdout1:
            print(f'netplan-script :: {stdout1}')
        if stderr1:
            print(f'netplan-script, error :: {stderr1}')
    else:
        print()
        print(f'netplan-script :: 01-netcfg.yaml does not already exists, creating a new one')

    process2 = subprocess.Popen(['sudo cp netcfg.yaml /etc/netplan/01-netcfg.yaml'],
                                shell=True,
                                stdout=subprocess.PIPE,
                                stderr=subprocess.PIPE)

    # Getting output logs and error logs
    stdout2, stderr2 = process2.communicate()
    if stdout2:
        print(f'netplan-script :: {stdout2}')
    if stderr2:
        print(f'netplan-script, error :: {stderr2}')

    process3 = subprocess.Popen(['sudo netplan apply'],
                                shell=True,
                                stdout=subprocess.PIPE,
                                stderr=subprocess.PIPE)

    print('netplan-script :: running sudo netplan apply')

    # Getting output logs and error logs
    stdout3, stderr3 = process3.communicate()
    if stdout3:
        print(f'netplan-script :: {stdout3}')
    if stderr3:
        print(f'netplan-script, error :: {stderr3}')


    if is_dhcp and is_em_behind_nat:
        sleep(20)
        process4 = subprocess.Popen(['ifconfig'],
                                    shell=True,
                                    stdout=subprocess.PIPE,
                                    stderr=subprocess.PIPE)

        print('netplan-script :: running sudo netplan apply')

        # Getting output logs and error logs
        stdout4, stderr4 = process4.communicate()
        if stdout4:
            print(f'netplan-script :: {stdout4}')
        if stderr4:
            print(f'netplan-script, error :: {stderr4}')

    print()
    print()

    if is_em_behind_nat and is_dhcp:
        print("Please enter VM details")
        addresses = input('Enter VM ip address: ')

    input_func(em_ip_address=addresses, is_em_behind_nat=is_em_behind_nat)


if __name__ == '__main__':
    main()
