#!/bin/bash
# Copy Compose from upgrade folder to EM_PATH
EM_PATH="/opt/inseego/bin/edge_manager"
NGINX_PATH="/opt/inseego/srv"
echo "EM deployed in Cloud or Private network?
Choose 1 for Cloud and 2 for Private"
read flag
if [ $flag == 1 ]
then
  cd /home/$USER/upgrade/aws && cp docker-compose.yaml $EM_PATH/docker-compose.yaml
elif [ $flag == 2 ]
then
  cd /home/$USER/upgrade/esxi && cp docker-compose.yaml $EM_PATH/docker-compose.yaml
else
  exit 1;
fi
#Changing the Ownership of $EM_PATH directory
sudo chown $USER:$USER $EM_PATH/* $EM_PATH/.env
cd $NGINX_PATH && sudo chown $USER:$USER .
#AWS ECR Authentication for pulling docker images
aws ecr get-login-password --region us-west-2 | docker login --username AWS --password-stdin 836891784212.dkr.ecr.us-west-2.amazonaws.com > /dev/null
cat $EM_PATH/.env | grep -q 'EM_VERSION'
return=$?
if [ $return == 1 ]
then
	 sudo sed -i '2 a EM_VERSION=2023.3.1.0' $EM_PATH/.env
else
	 sudo sed -i "s/EM_VERSION=.*/EM_VERSION=2023.3.1.0/g" $EM_PATH/.env
fi
cat $EM_PATH/.env | grep -q 'LOGGING_LEVEL'
log=$?
if [ $log == 1 ]
then
	 sudo sed -i '3 a LOGGING_LEVEL=DEBUG' $EM_PATH/.env
fi
cat $EM_PATH/.env | grep -q 'DEBIAN_REPO_URL'
repo=$?
if [ $repo == 1 ]
then
	sudo sed -i '4 a DEBIAN_REPO_URL=https://repo.inseego5g.net/debs/' $EM_PATH/.env
fi
cat $EM_PATH/.env | grep -q 'CURRENT_ENV'
env=$?
if [ $env == 1 ]
then
	sudo sed -i '5 a CURRENT_ENV=prod' $EM_PATH/.env
fi
#Upgrading the EM to latest version
cd $EM_PATH && docker-compose up -d
#echo "Upgrading the EM to latest version"
sudo rm -rf /opt/2022.22.1.0/ > /dev/null 2>&1
cat $EM_PATH/.env | grep -q 'EM_VERSION=2023.3.1.0'
test=$?
if [ $test == 0 ]
then
    docker rmi -f fa36a975502a ca37fd75a579 > /dev/null 2>&1
    echo "EM upgraded successfully..."
else
	echo "EM upgrade failed..."
fi
sleep 10 
#Checking the docker container status after upgrading
docker ps

