#!/bin/bash
CURRENT="/opt/inseego"
# Copy Compose from upgrade folder to EM_PATH
EM_PATH="/opt/inseego/bin/edge_manager"
NGINX_PATH="/opt/inseego/srv"
echo "EM deployed in Cloud or Private network?
Choose 1 for Cloud and 2 for Private"
read flag
if [ $flag == 1 ]
then
  cd /home/$USER/upgrade/aws && cp docker-compose.yaml $EM_PATH/docker-compose.yaml
elif [ $flag == 2 ]
then
  cd /home/$USER/upgrade/esxi && cp docker-compose.yaml $EM_PATH/docker-compose.yaml
else
  exit 1;
fi
sudo chown $USER:$USER $EM_PATH/* $EM_PATH/.env
cd $NGINX_PATH && sudo chown $USER:$USER .
aws ecr get-login-password --region us-west-2 | docker login --username AWS --password-stdin 836891784212.dkr.ecr.us-west-2.amazonaws.com > /dev/null
cat /opt/inseego/bin/edge_manager/.env | grep -q 'EM_VERSION'
return=$?
if [ $return == 1 ]
then
	 sed -i '2 a EM_VERSION=2022.24.1.0' /opt/inseego/bin/edge_manager/.env
else
	 sed -i "s/EM_VERSION=.*/EM_VERSION=2022.24.1.0/g" /opt/inseego/bin/edge_manager/.env
fi
cat /opt/inseego/bin/edge_manager/.env | grep -q 'LOGGING_LEVEL'
log=$?
if [ $log == 1 ]
then
	 sed -i '3 a LOGGING_LEVEL=DEBUG' /opt/inseego/bin/edge_manager/.env
fi
cat /opt/inseego/bin/edge_manager/.env | grep -q 'DEBIAN_REPO_URL'
repo=$?
if [ $repo == 1 ]
then
	sed -i '4 a DEBIAN_REPO_URL=https://repo.inseego5g.net/debs/' /opt/inseego/bin/edge_manager/.env
fi
cat /opt/inseego/bin/edge_manager/.env | grep -q 'CURRENT_ENV'
env=$?
if [ $env == 1 ]
then
	sed -i '5 a CURRENT_ENV=prod' /opt/inseego/bin/edge_manager/.env
fi
sed -i '6 a LOG_DRIVER=json-file' /opt/inseego/bin/edge_manager/.env
cd $EM_PATH && docker-compose up -d
echo "Upgrading the EM to latest version"
cat /opt/inseego/bin/edge_manager/.env | grep -q 'EM_VERSION=2022.24.1.0'
test=$?
if [ $test == 0 ]
then
	docker rmi -f 7521461872fb 2d990140f2c3 6590b41bb5d1 8188a33232f1 4f442b3865c5 75684e74c244 15c68cf73b1e 0812ecd32132 988391fd5be7 7ae2a9767d6e 7858f294bb90 097463f3e4f9 6a543fd2cff2 523a29705292 285cfe7cf15e f63c5e84dd31 454711af3d3a e2009d08aec6 > /dev/null 2>&1 
else
	echo "EM upgrade failed..."
fi
sleep 20
docker ps
