#!/bin/bash
CURRENT="/opt/inseego"
# Copy Compose from upgrade folder to EM_PATH
EM_PATH="/opt/inseego/bin/edge_manager"
KEY_ID="$(echo QUtJQTRGV1ZER1FLTUhQWFBJWlUK | base64 --decode)"
KEY_VALUE="$(echo b2NraGJXMkhCRzdhaHpDYkVhZmpYcjE2NHlpaVRWamYrMmUxc2VsaQo= | base64 --decode)"
AWS_REGION="us-west-1"
aws configure set aws_access_key_id "$KEY_ID" && aws configure set aws_secret_access_key "$KEY_VALUE" && aws configure set region "$AWS_REGION" && aws configure set output "text"
echo "EM deployed in Cloud or Private network?
Choose 1 for Cloud and 2 for Private"
read flag
if [ $flag == 1 ]
then
  cd /home/$USER/upgrade/aws && cp docker-compose.yaml $EM_PATH/docker-compose.yaml
elif [ $flag == 2 ]
then
  cd /home/$USER/upgrade/esxi && cp docker-compose.yaml $EM_PATH/docker-compose.yaml
else
  exit 1;
fi
sudo chown $USER:$USER $EM_PATH/* $EM_PATH/.env $EM_PATH/.
aws ecr get-login-password --region us-west-2 | docker login --username AWS --password-stdin 836891784212.dkr.ecr.us-west-2.amazonaws.com
cat /opt/inseego/bin/edge_manager/.env | grep -q 'EM_VERSION'
return=$?
if [ $return == 1 ]
then
	 sed -i '2 a EM_VERSION=2022.17.1.0' /opt/inseego/bin/edge_manager/.env
else
	 sed -i "s/EM_VERSION=.*/EM_VERSION=2022.17.1.0/g" /opt/inseego/bin/edge_manager/.env
fi
cat /opt/inseego/bin/edge_manager/.env | grep -q 'LOGGING_LEVEL'
log=$?
if [ $log == 1 ]
then
	 sed -i '3 a LOGGING_LEVEL=DEBUG' /opt/inseego/bin/edge_manager/.env
fi
sed -i '4 a ZBX_MEMORYLIMIT=256M' /opt/inseego/bin/edge_manager/.env
sed -i '5 a ZBX_UPLOADMAXFILESIZE=32M' /opt/inseego/bin/edge_manager/.env
sed -i '6 a ZBX_POSTMAXSIZE=32M' /opt/inseego/bin/edge_manager/.env
sed -i '7 a ZBX_STARTTRAPPERS=5' /opt/inseego/bin/edge_manager/.env
sed -i '8 a ZBX_HISTORYCACHESIZE=128M' /opt/inseego/bin/edge_manager/.env
sed -i '9 a ZBX_TRENDCACHESIZE=64M' /opt/inseego/bin/edge_manager/.env
sed -i '10 a ZBX_HISTORYINDEXCACHESIZE=64M' /opt/inseego/bin/edge_manager/.env
sed -i '/MA_ADMIN_USERNAME=ma_admin/d' /opt/inseego/bin/edge_manager/.env
sed -i '/MA_ADMIN_PASSWORD=RGVmYXVsdEAxMjM=/d' /opt/inseego/bin/edge_manager/.env 
cd $EM_PATH && docker-compose up -d
echo "Upgrading the EM to latest version"
sleep 40
docker ps
